
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_PROGRESS_CLASS_H
#define PG_PROGRESS_CLASS_H

class OLog;
class ILog;

// global progress record, updated by stat cycles
class Progress {
	public:
		Progress();

		int xacts() const { return theXactCnt; }
		int errs() const { return theErrCnt; }
		Time time() const;

		void success() { theXactCnt++; }
		void failure() { theErrCnt++; }

		void store(OLog &ol) const;
		void load(ILog &il);
		ostream &print(ostream &os) const;

	protected:
		Time theTimestamp; // place to keep Clock after load()
		int theXactCnt; // successful completions
		int theErrCnt;  // failed transactions
};

extern Progress TheProgress;

#endif
