
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_CACHE_POLICY_H
#define PG_CACHE_POLICY_H

#include "xstd/Queue.h"
#include "cache/CacheEntry.h"

class Cache;

// we will generalize the policy class iff needed

class CachePolicy {
	public:
		CachePolicy(Cache *aCache);
		~CachePolicy();

		bool canAdmit(CacheEntry *e) { return e != 0; }
		void noteAdmitted(CacheEntry *e) { theQueue.enqueue(e); }
		void notePurged(CacheEntry *e) { theQueue.dequeue(e); }

		CacheEntry *nextVictim() { return theQueue.firstOut(); }

	protected:
		Queue<CacheEntry> theQueue;
		Cache *theCache;
};

#endif
