
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#include "base/polygraph.h"

#include "xstd/Clock.h"
#include "client/SyncClt.h"


void SyncClt::noteXactDone(CltXact *x) {
	Client::noteXactDone(x);
	tryLaunch();
}

// note: only called after launch win delay and via launchFailed()
void SyncClt::wakeUp(const Alarm &a) {
	Client::wakeUp(a);
	tryLaunch();
}

void SyncClt::scheduleLaunch(Time) {
	Assert(!thePendAlarmCnt);
	Assert(!theThinkDistr);
	tryLaunch(genXact());
}

void SyncClt::launchFailed(CltXact *x) {
	Client::launchFailed(x);

	// if no alarms are pending, we may get stuck and submit
	// no more xactions; this is a kludge
	if (!isIdle && !thePendAlarmCnt && !theCcXactLvl)
		sleepTill(TheClock); // submit more next cycle
}
