
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_INJECTION_ITERATOR_H
#define PG_INJECTION_ITERATOR_H

#include "xstd/Rnd.h"

class RndDistr;
class ContentCfg;
class CdbBodyIter;
class TextDbase;
class WrBuf;


class InjectIter {
	public:
		InjectIter() { reset(); }

		void reset();

		void creator(ContentCfg *aCreator) { theCreator = aCreator; }
		ContentCfg *creator() { return theCreator; }

		void textDbase(TextDbase *aTdb) { theTdb = aTdb; }
		void gap(RndDistr *aGap) { theInjGap = aGap; }

		void start(CdbBodyIter *aBodyIter);
		void inject(WrBuf &buf, Size areaOff, Size areaLen);

	protected:
		ContentCfg *theCreator;
		TextDbase *theTdb;
		CdbBodyIter *theBodyIter;

		RndDistr *theInjGap;
		Size theInjOff;
		
		RndGen theTdbPosGen;
		int theTdbPos;      // pos in text database

		bool incInjOff;     // generate new injection pos
};

#endif
