
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_AGENT_SYMBOL_H
#define PG_AGENT_SYMBOL_H

#include "pgl/HostsBasedSym.h"
#include "base/UniqId.h"

class StrIdentifier;
class StringSym;
class SocketSym;
class PopModelSym;

// base class for robot and server symbols
class AgentSym: public HostsBasedSym {
	public:
		AgentSym(const String &aType);
		AgentSym(const String &aType, PglRec *aRec);

		virtual bool isA(const String &type) const;

		String kind() const;
		UniqId world() const;
		SocketSym *socket() const;
		RndDistr *xactThink() const;
		RndDistr *pconnUseLmt() const;
		Time idlePconnTimeout() const;
		PopModelSym *popModel() const;
		bool msgTypes(Array<StringSym*> &types, Array<double> &tprobs) const;
		RndDistr *msgTypes(const StrIdentifier &typeNames) const;
		bool abortProb(double &p) const;

	protected:
		virtual const char *msgTypesField() const = 0;
		RndDistr *namesToDistr(const String &fieldName, const StrIdentifier &names) const;
		
};

#endif
