
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PGL_CONTAINER_SYMBOL_H
#define PGL_CONTAINER_SYMBOL_H

#include "pgl/PglExprSym.h"

// one expression can represent more than one SynSym,
// with optional per-item probabilities
class ContainerSym: public ExpressionSym {
	public:
		ContainerSym(const char *aType): ExpressionSym(aType) {}

		virtual int count() const = 0;
		virtual bool probsSet() const = 0;

		// offset must be between 0 and count-1
		virtual const SynSym *itemProb(int offset, double &prob) const = 0;

		const SynSym *operator[](int offset) const { return item(offset); }
		const SynSym *item(int offset) const;
		//double prob(int offset) const;

		virtual bool isA(const String &type) const;
};

#endif
