
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#include "base/polygraph.h"

#include "probe/ProbeClt.h"
#include "probe/ProbeCltXact.h"


ProbeCltXact::ProbeCltXact(const NetAddr &aCltHost, const NetAddr &aSrvHost, int fd):
	ProbeXact(aCltHost, aSrvHost, fd) {
}

ProbeAgent *ProbeCltXact::owner() {
	return theOwner;
}

const ProbeAgent *ProbeCltXact::owner() const {
	return theOwner;
}

void ProbeCltXact::exec(ProbeClt *anOwner) {
	theOwner = anOwner;
	ProbeXact::exec();
	noteWriteReady(theWriteR.fd()); // assume we are ready to write
}
