
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_PROXY_APPLICATION_H
#define PG_PROXY_APPLICATION_H

#include "app/PolyApp.h"

class IcpBase;

class PolyPxy: public PolyApp {
	public:
		PolyPxy();

	protected:
		virtual void configure();
		virtual void reportCfg();
		virtual void step();
		
		virtual void startAgents();
		virtual void getHostAddrs(Array<NetAddr*> &) const {}
		virtual NetAddrSym *getAgentAddrMask() const { return 0; }
		virtual void getOpts(Array<OptGrp*> &opts);
		virtual void makeAgent(const AgentCfg &cfg);
		virtual void logState(OLog &log);

		virtual const String sideName() const;
		virtual int logCat() const;

		void addIcpAgent(IcpBase *icpAgent);

	protected:
		Array<IcpBase*> theIcpAgents;
};

#endif
