
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_POLYGRAPH_OLOG_H
#define PG_POLYGRAPH_OLOG_H

#include "xstd/AlarmClock.h"
#include "base/OLog.h"

// records current time and progress info when time changes
// flushes the log from time to time
// writes magic markers
class PolyOLog: public OLog, public AlarmUser {
	public:
		PolyOLog();

		void period(Time aPeriod);

		virtual void begEntry(int tag);
		virtual void wakeUp(const Alarm &alarm);

	protected:
		virtual void putHeader();
		virtual void putTrailer();

	protected:
		Time thePeriod;
		Time theModTime;
};

extern PolyOLog TheOLog;
extern PolyOLog *TheSmplOLog;

#endif
