
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_XML_DOCUMENT_H
#define PG_XML_DOCUMENT_H

#include "xml/XmlNode.h"

class ostream;
class String;

// well-formed documents must have a single root element
// XmlDoc manages that element and provides some
// global functionality that XmlNode does not have
class XmlDoc {
	public:
		XmlDoc();
		~XmlDoc();

		XmlNode *root() { return theRoot; }
		void root(const XmlNode &aRoot);

		ostream &print(ostream &os, const String &pfx) const;

	protected:
		XmlNode *theRoot;
};

#endif
