
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#include "base/polygraph.h"

#include "xml/XmlText.h"
#include "xml/XmlSection.h"

String XmlSection::TagName(int level) {
	ostrstream buf;
	buf << "sect" << level << ends;
	String s = buf.str();
	ostrstreamFreeze(buf, false);
	return s;
}

XmlSection::XmlSection(int level): XmlTag(TagName(level)) {
}

XmlSection::XmlSection(int level, const String &title): XmlTag(TagName(level)) {
	XmlTag t("title");
	t << XmlText(title);
	(*this) << t;
}
